package com.hbzh.sdkexample;

import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.RadioGroup;

public class AddDeviceActivity extends AppCompatActivity {

    DeviceSnFragment deviceSnFragment;
    DeviceDomainFragment deviceDomainFragment;
    RadioGroup mRadioGroup;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add_device);

        FragmentManager fm = getFragmentManager();
        deviceSnFragment = (DeviceSnFragment)fm.findFragmentById(R.id.fragment_device_sn);
        deviceDomainFragment = (DeviceDomainFragment)fm.findFragmentById(R.id.fragment_device_domain);

        FragmentTransaction ft = fm.beginTransaction();
        ft.hide(deviceDomainFragment);
        ft.commitAllowingStateLoss();

        mRadioGroup = (RadioGroup)findViewById(R.id.radio_group_add);
        mRadioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                FragmentTransaction ft = getFragmentManager().beginTransaction();

                switch (checkedId)
                {
                    case R.id.radio_btn_sn:
                        ft.show(deviceSnFragment);
                        ft.hide(deviceDomainFragment);
                        ft.commitAllowingStateLoss();
                        break;

                    case R.id.radio_btn_ip:
                        ft.show(deviceDomainFragment);
                        ft.hide(deviceSnFragment);
                        ft.commitAllowingStateLoss();
                        break;

                    default:
                        break;
                }
            }
        });
    }
}
