package com.hbzh.sdkexample;

import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.content.LocalBroadcastManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.hanbang.ydtsdk.AlarmParam;
import com.hanbang.ydtsdk.YdtDeviceInfo;
import com.hanbang.ydtsdk.YdtDeviceParam;
import com.hanbang.ydtsdk.YdtNetSDK;

import java.util.ArrayList;
import java.util.List;


public class DeivceListFragment extends Fragment
{

    /**
     * 添加设备按钮
     */
    Button mButton;

    /**
     * 设备列表
     */
    ListView deviceList;

    /**
     * 设备
     */
    List<YdtDeviceParam> deviceParam;

    ProgressDialog dialog;

    @Override
    public void onCreate( Bundle savedInstanceState )
    {
        super.onCreate( savedInstanceState );
    }

    @Override
    public View onCreateView( LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState )
    {
        // Inflate the layout for this fragment
        View view = inflater.inflate( R.layout.fragment_deivce_list, container, false );

        initView( view );

        return view;
    }

    @Override
    public void onResume()
    {
        super.onResume();
        //刷新账户下设备
        getAccountDevice();
    }

    //初始化界面
    private void initView( View view )
    {
        mButton = (Button) view.findViewById( R.id.add_device );
        mButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getActivity(), AddDeviceActivity.class);
                getActivity().startActivity(intent);
            }
        });

        //获取账户下设备
/*        view.findViewById( R.id.get_devices ).setOnClickListener( new View.OnClickListener()
        {
            @Override
            public void onClick( View v )
            {
                getAccountDevice();
            }
        } );*/


        deviceList = (ListView) view.findViewById( R.id.device_list );
        dialog = new ProgressDialog( getActivity() );
        dialog.setProgressStyle( ProgressDialog.STYLE_SPINNER );
        dialog.setMessage( "请稍等。。。" );
        dialog.setCancelable( false );

    }

    /**
     * 获取账号下设备
     * @return
     */
    public void getAccountDevice()
    {
        deviceParam = new ArrayList<YdtDeviceParam>(  );

        dialog.show();
        //获取账户下设备
        new Thread( new Runnable()
        {
            @Override
            public void run()
            {
                YdtNetSDK ydtNetSDK = AccountInfo.getInstance().getYdtNetSDK();
                //获取设备
                YdtDeviceInfo ydtDeviceInfo = ydtNetSDK.getDevicesBelongsToAccount();
                if ( ydtDeviceInfo.nErrorCode == 0 )
                {
                    deviceParam.addAll( ydtDeviceInfo.deviceList );
                    AccountInfo.getInstance().setYdtDeviceInfos( deviceParam );
                    mButton.post( new Runnable()
                    {
                        @Override
                        public void run()
                        {
                            dialog.dismiss();
                            DeviceListAdapter adaper = new DeviceListAdapter( getActivity(),deviceParam );
                            deviceList.setAdapter( adaper );
                            Toast.makeText( getActivity(), "获取设备成功！", Toast.LENGTH_SHORT ).show();
                        }
                    } );
                }
            }
        } ).start();
    }

    /**
     * ListView适配器
     */
    class DeviceListAdapter extends BaseAdapter
    {

        private LayoutInflater mInflater;
        private List<YdtDeviceParam> devices;

        public DeviceListAdapter( Context context,List<YdtDeviceParam> deviceParams )
        {
            mInflater = LayoutInflater.from( context );
            this.devices = deviceParams;
        }
        @Override
        public int getCount()
        {
            return devices.size();
        }

        @Override
        public Object getItem( int position )
        {
            return devices.get( position );
        }

        @Override
        public long getItemId( int position )
        {
            return 0;
        }

        @Override
        public View getView( final int position, View convertView, ViewGroup parent )
        {
            ViewHolder viewHolder = null;
            if ( convertView == null )
            {
                viewHolder = new ViewHolder();
                convertView = mInflater.inflate( R.layout.device_list_item, null );
                viewHolder.mDeviceSn = (TextView) convertView.findViewById( R.id.device_sn );
                viewHolder.mDelete = (Button) convertView.findViewById( R.id.delete_btn );
                convertView.setTag( viewHolder );
            }
            else
            {
                viewHolder = (ViewHolder) convertView.getTag();
            }
            viewHolder.mDeviceSn.setText( devices.get( position ).devSN );

            //删除设备
            viewHolder.mDelete.setOnClickListener( new View.OnClickListener()
            {
                @Override
                public void onClick( View v )
                {
                    dialog.show();
                    new Thread( new Runnable()
                    {
                        @Override
                        public void run()
                        {
                            YdtNetSDK ydtSdk = AccountInfo.getInstance().getYdtNetSDK();
                            //删除设备
                            int error = ydtSdk.deleteDevice( devices.get( position ).devId );
                            if ( error == 0 )
                            {
                                AccountInfo.getInstance().removeDeviceFromList(devices.get( position ).devSN);
                                deviceParam.remove(position);

                                deviceList.post( new Runnable()
                                {
                                    @Override
                                    public void run()
                                    {
                                        dialog.dismiss();
                                        notifyDataSetChanged();
                                        Toast.makeText( getActivity(), "删除成功", Toast.LENGTH_SHORT ).show();
                                    }
                                } );

                            }
                        }
                    } ).start();
                }
            } );
            return convertView;
        }
    }

    class ViewHolder
    {
        TextView mDeviceSn;
        Button mDelete;
    }

}
